package com.starbuds.server.service.feed.dao;

import com.starbuds.server.common.pojo.db.FeedActionDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

/**
 * 用户操作记录（点赞、收藏、分享等）
 */
@Mapper
@Repository
public interface FeedActionDAO {

    /**
     * 插入或更新
     *
     * @param actionDO
     * @return
     */
    int insertOrUpdate(FeedActionDO actionDO);

    /**
     * 判断是否存在
     *
     * @param userId
     * @param targetId
     * @param targetType
     * @param actionType
     * @return
     */
    int countById(@Param("userId") Long userId,
                  @Param("targetId") Long targetId,
                  @Param("targetType") Integer targetType,
                  @Param("actionType") Integer actionType);

    /**
     * 根据id和状态查询
     *
     * @param userId
     * @param targetId
     * @param targetType
     * @param actionType
     * @param status
     * @return
     */
    int countByIdAndStatus(@Param("userId") Long userId,
                           @Param("targetId") Long targetId,
                           @Param("targetType") Integer targetType,
                           @Param("actionType") Integer actionType,
                           @Param("status") Integer status);
}
