package com.starbuds.server.service.feed.dao;

import com.starbuds.server.common.pojo.common.KeyValueMapDO;
import com.starbuds.server.common.pojo.db.FeedThumbsupLogDO;
import com.starbuds.server.common.pojo.daoplus.QueryWrapper;
import com.starbuds.server.common.pojo.daoplus.UpdateWrapper;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * Mapper
 */
@Mapper
@Repository
public interface FeedThumbsupLogDAO {

    /**
     * 插入数据
     */
    int insert(FeedThumbsupLogDO po);

    /**
     * 插入批量数据
     */
    int insertBatch(List<FeedThumbsupLogDO> list);

    /**
     * 插入或更新数据
     */
    int insertOrUpdate(FeedThumbsupLogDO po);

    /**
     * 更新数据
     */
    int update(UpdateWrapper uw);

    /**
     * 查询一条记录
     */
    FeedThumbsupLogDO selectOne(QueryWrapper qw);

    /**
     * 查询所有记录
     */
    FeedThumbsupLogDO selectList(QueryWrapper qw);

    /**
     * 查询总数
     */
    int selectCount(QueryWrapper qw);

    /**
     * 查询列表(分页)
     */
    List<FeedThumbsupLogDO> selectPageList(QueryWrapper qw);

    FeedThumbsupLogDO getItemByParam(@Param("feedId") Long feedId, @Param("userId") Long userId);

    void updateIsDel(@Param("hisId") Long hisId, @Param("isDel") int isDel);

    Integer getThumbsUpCount(@Param("feedId") Long feedId);

    /**
     * 获取点赞数量
     *
     * @param feedIds
     * @return
     */
    List<KeyValueMapDO> getThumbsNumList(@Param("feedIds") List<Long> feedIds);

    /**
     * 获取点赞过的集合
     *
     * @param feedIds
     * @param userId
     * @return
     */
    Set<Long> getThumbsUpSet(@Param("feedIds") List<Long> feedIds, @Param("userId") Long userId);
}