package com.starbuds.server.service.feed.impl;

import cn.hutool.core.collection.CollectionUtil;
import com.starbuds.server.common.pojo.feed.FeedActivityInfoItemVO;
import com.starbuds.server.common.pojo.feed.FeedActivityInfoVO;
import com.starbuds.server.common.service.data.ReleaseConfigService;
import com.starbuds.server.common.service.feed.FeedActivityInfoService;
import com.starbuds.server.service.feed.dao.FeedActivityInfoDAO;
import lombok.extern.slf4j.Slf4j;
import org.apache.dubbo.config.annotation.Reference;
import org.apache.dubbo.config.annotation.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author: ruomu
 * @date: 2021/11/26 created
 */
@Service(version = "1.0.0")
@Slf4j
public class FeedActivityInfoServiceImpl implements FeedActivityInfoService {

    @Resource
    FeedActivityInfoDAO feedActivityInfoDAO;

    @Reference(version = "1.0.0")
    ReleaseConfigService releaseConfigService;

    @Override
    public FeedActivityInfoVO getFeedActivityInfo(Long infoId) {
        return feedActivityInfoDAO.getInfo(infoId);
    }

    @Override
    public List<FeedActivityInfoItemVO> getFeedActivityInfoItesm(Long infoId) {
        return feedActivityInfoDAO.getItems(infoId);
    }

    /**
     * 首页资讯列表
     *
     * @return
     */
    @Override
    public List<FeedActivityInfoVO> getMainPageFeedActivityInfoList() {
        List<FeedActivityInfoVO> res = feedActivityInfoDAO.getMainPageFeedActivityInfoList();
        String baseUrl = releaseConfigService.getCachReleaseConfig("activityFeedUrl");
        if (CollectionUtil.isNotEmpty(res)) {
            res.forEach(i -> i.setTargetUrl(baseUrl + "infoId=" + i.getInfoId() + "&showStyle=0"));
        }
        return res;
    }
}
