package com.starbuds.server.service.feed.rocket;

import com.aliyun.openservices.ons.api.PropertyKeyConst;
import com.starbuds.server.common.pojo.message.AliyunConfig;
import com.starbuds.server.common.service.core.ConfigService;
import org.apache.dubbo.config.annotation.Reference;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;

import javax.annotation.PostConstruct;
import java.util.Properties;

/**
 * 配置
 *
 * @author aoe
 * @date 2020/5/28
 */
@Configuration
public class RocketConfig {

    @Reference(version = "1.0.0")
    private ConfigService configService;

    @Value("${aliyun.rocket.namesrv}")
    private String rocketNamesrv;

    @Value("${aliyun.rocket.groupId}")
    private String rocketGroupId;

    private Properties props;

    @PostConstruct
    private void init() {
        AliyunConfig aliyunAccessConfig = configService.getAliyunConfig();

        // Rocket MQ
        props = new Properties();
        props.put(PropertyKeyConst.AccessKey, aliyunAccessConfig.getAccessKey());
        props.put(PropertyKeyConst.SecretKey, aliyunAccessConfig.getAccessSecret());
        props.put(PropertyKeyConst.NAMESRV_ADDR, rocketNamesrv);
        props.put(PropertyKeyConst.GROUP_ID, rocketGroupId);
    }

    public Properties getProps() {
        return props;
    }
}
